(function(){
	this.djdata = {
		notes:[],
		comments:[],
		votes:{}
	}
	this.setupTemplates = function(){
	    Template7.registerHelper("avatar",function(avatar,options){
		    if(avatar != undefined && avatar != ""){
			    return avatar
		    }
		    return "img/me/default_portrait.png"
	    })
	    Template7.registerHelper("ftimestamp",function(timestamp,options){
            var date = new Date(timestamp * 1000)
            return date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes()
        })
	    this.templates = {}
	    if(document.getElementById("comments-template")!=undefined){
		    this.templates.comments = Template7(document.getElementById("comments-template").innerHTML).compile()
	    }
	    if(document.getElementById("profile-template") != undefined){
		    this.templates.profile = Template7(document.getElementById("profile-template").innerHTML).compile()
	    }
	    if(document.getElementById("articile-template") != undefined){
		    this.templates.article = Template7(document.getElementById("articile-template").innerHTML).compile()
	    }
	}
	this.setupUpUserEvents =function(type){
		$(type+" .upvote").click(function(){
			var commentId = parseInt($(this).attr("comment-id"))
			var type = parseInt($(this).attr("type"))
			var upvoteCount = parseInt($(this).children("span").text())
			var action = type == 2 ? 0 : 1
			var element = $(this)
			dj.postWithCallback("upVoteNote",{commentId:commentId,action:action},function(para){
				var newtype = action == 0 ? 1:2
				var newUpvoteCount = action == 1 ? upvoteCount + 1 : upvoteCount - 1
				element.attr("type",newtype)
				element.children("span").text("" + newUpvoteCount)
				element.first().children().first().attr("src","img/comment/comment_upvote_"+newtype+".png")
			})
		})
		$(type + " .user .info").click(function(){
			var userid = parseInt($(this).attr("user-id"))
			var canshowDetail = $(this).attr("show-detail")
			if (canshowDetail == 'true'){
				window.dj.post("showUserHomeView",{userid:userid})
			}
		})
		$(type + " .comments .content").click(function(){
			var commentId = parseInt($(this).attr("comment-id"))
			window.dj.post("showNoteDetail",{commentId:commentId})
		})
		if (type == "notes"){
			$("notes .more").click(function(){
				window.dj.post("showNoteList",{})
			})
		}
		if (type == "comments"){
			$("comments .more").click(function(){
				window.dj.post("showValuableNoteList",{})
			})
		}
	}
	this.updateImageSize=function(){
		$(".image").each(function(){
			var width = (window.innerWidth - 30) * 0.3
			$(this).height(width)
		})
	}
	this.getArticleContent = function(){
		return dj.nativecallback({callback:"article_content",data:$("article").get(0).textContent.trim()})
	}
	this.loadArticle = function(para){
		this.djdata.article = para.article
		document.getElementById("article-container").innerHTML = this.templates.article(para)
		setupArticleEvent()
	}
	this.renderCommentsView =function(type,target,template,comments,title){
		comments.map(function(e){
			e.user.level = Math.max(1,e.user.level)
			e.viewvote_visiable = (type === "comments")
			if(this.djdata.votes != undefined && this.djdata.votes.up != undefined){
				e.up_vote_type = !(this.djdata.votes.up.indexOf(e.id) >= 0) ? 1 : 2
			}else{
				e.up_vote_type = 1
			}
		})
		target.innerHTML = template({
			contenttype:type,
			comments:comments,
			home:this.djdata.home,
			comment_section_title:title
		})
		setupUpUserEvents(type)
		updateImageSize()
	}
	this.renderNotes = function(){
		renderCommentsView(
			"notes",
			document.getElementById("notes-container"),
			this.templates.comments,
			this.djdata.notes,
			"我的笔记"
		)
	}
	this.renderComments = function(){
		renderCommentsView(
			"comments",
			document.getElementById("comments-container"),
			this.templates.comments,
			this.djdata.comments,
			"精选笔记"
		)
	}
	this.updateNoteListViews = function(){
		var hasnote = this.djdata.notes.length > 0
		var hascomment = this.djdata.comments.length > 0
		if(hasnote){
			this.renderNotes()
		}
		if(hascomment){
			this.renderComments()
		}
		if(!hasnote && !hascomment){
			this.renderComments()
			$("comments").show()
			$("notes").hide()
		}else{
			if(hasnote){
				$("notes").show()
			}else{
				$("notes").hide()
			}
			if(hascomment){
				$("comments").show()
			}else{
				$("comments").hide()
			}
		}
		$(".actionarea").css({
			display:"block"
		})
	}
	this.loadNotes = function(para){
		this.djdata.notes = para.notes
		if(para.votes != undefined){
			this.djdata.votes = para.votes
		}
		this.updateNoteListViews()
	}
	this.loadComments = function(para){
		this.djdata.comments = para.notes
		if(para.votes != undefined){
			this.djdata.votes = para.votes
		}
		this.updateNoteListViews()
	}
	this.loadNoteVotes = function(para){
		this.djdata.votes = para.votes
		this.updateNoteListViews()
	}
	this.loadUserInfo = function(para){
		this.djdata.home = para.home
		document.getElementById("profile-container").innerHTML = this.templates.profile(para)
	}
	this.setupArticleEvent = function(){
	    $(".dj-tipinfo").click(function(e) {
	       var objectType = $(this).attr("object-type")
	       var objectId = $(this).attr("object-id")
	       var extra = unescape($(this).attr("object-extra"))
	       var para = {}
	       if (extra == "undefined"){
	          extra = "{}"
	       }
		   para.objectType = objectType
	       para.extra = JSON.parse(extra)
		   para.objectId = parseInt(objectId)
		   para.locationX = parseInt(e.pageX)
		   para.locationY = parseInt(e.pageY)
	       window.dj.post("showTipView",para)
	    })
	}
    this.setArticleFontstyle = function(para){
        this.djdata.fontstyle = para
        $('#font-stylesheet').attr('href',"css/article_font_style_"+para.fontstyle+".css");
        window.dj.post("onContentResize",{
	        height:document.body.clientHeight,
	        width:document.body.clientWidth
        })
    }
	this.djsetup = function(){
		this.setupTemplates()
	    this.setupArticleEvent()
	    $(".write-comment").click(function(){
			window.dj.post("writeComment",{})
		})
        $("articlecontainer img").click(function(){
            var images = $("articlecontainer img").map(function(m,n){
                return n.src + ""
            }).toArray()
            var current = $(this).get(0).src
            window.dj.post("previewImage",{
                list:images,
                index:images.indexOf(current)
            })
        })
	}
}).call(window)

$(document).ready(function() {
	window.djsetup()
	window.dj.post("pageLoadComplete",{})
})	