var dj = {}
dj.os = {}
dj.os.isIOS = /iOS|iPhone|iPad|iPod/i.test(navigator.userAgent)
dj.os.isAndroid = !dj.os.isIOS
dj.callbackname = function(){
	return "djapi_callback_" + (new Date()).getTime() + "_" + Math.floor(Math.random() * 10000)
}
dj.callbacks = {}
dj.addCallback = function(name,func,userdata){
	delete dj.callbacks[name]
	dj.callbacks[name] = {callback:func,userdata:userdata}
}

dj.callback = function(para){
	var callbackobject = dj.callbacks[para.callbackname]
	if (callbackobject != undefined){
		if (callbackobject.userdata != undefined){
			callbackobject.userdata.callbackData = para
		}
		callbackobject.callback(para)
		delete dj.callbacks[para.callbackname]
	}
}

dj.post = function(cmd,para){
	if(dj.os.isIOS){
		var message = {}
		message.meta = {
			cmd:cmd
		}
		message.para = para || {}
		window.webview.post(message)
	}else if(window.dj.os.isAndroid){
		window.webview.post(cmd,JSON.stringify(para))
	}
}
dj.postWithCallback = function(cmd,para,callback){
	var callbackname = dj.callbackname()
	dj.addCallback(callbackname,callback,{})
	if(dj.os.isIOS){
		var message = {}
		message.meta  = {
			cmd:cmd,
			callback:callbackname
		}
		message.para = para
		window.webview.post(message)
	}else if(window.dj.os.isAndroid){
	    para.callback = callbackname;
		window.webview.post(cmd,JSON.stringify(para))
	}
}
/*
	event base api
*/
dj.dispatchEvent = function(para){
	var event = new Event(para.name)
	event.para = para.para
	window.dispatchEvent(event)
}
dj.addEventListener = window.addEventListener

dj.stringify = function(obj){
	var type = typeof obj 
	if (type == "object"){
		return JSON.stringify(obj)
	}else {
		return obj
	}
}
dj.nativecallback = function(obj){
	if(dj.os.isIOS){
		return dj.stringify(obj.data)
	}else if(window.dj.os.isAndroid){
		window.webview.post(obj.callback,dj.stringify(obj))
	}
}

dj.http = function(para){
	var http = {}
	http.httpara = para != undefined ? para : {}
	http.httpara.donecallbackname = dj.callbackname()
	http.done = function(callback){
		http.donecallback = callback
		return http
	}
	http.paras = function(theparas){
		http.httpara.paras = theparas
		return http
	}
	http.headers = function(theheaders){
		http.httpara.headers = theheaders
		return http
	}
	http.files = function(thefiles){
		http.httpara.files = thefiles
		return http
	}
	http.run = function(){
		dj.addCallback(http.httpara.donecallbackname,http.donecallback,http)
		dj.post("djapi",http.httpara)
		return http
	}
	return http
}

dj.getSelectionText = function(){
	return dj.nativecallback({callback:"select_text",data:document.getSelection().toString()})
}

dj.parseQuery = function(query){
    var reg = /([^=&\s]+)[=\s]*([^=&\s]*)/g;
    var obj = {};
    while(reg.exec(query)){
        obj[RegExp.$1] = RegExp.$2;
    }
    return obj;
}
dj.parseUrl = function(url){
  var a = document.createElement('a')
  a.href = url
  var querys = dj.parseQuery((a.search || "").replace("?",""))
  return { protocol:a.protocol || "",host:a.host || "",querys:querys,path:a.pathname || "" }
}
window.dj = dj