var RE = {}
RE.editor = document.getElementById('editor')
RE.imgid = 0
RE.editor.addEventListener("input", function() {
    RE.updatePlaceholder()
})
RE.setCaretEnd = function(){
    var el = RE.editor
    var range = document.createRange();
    var sel = window.getSelection();
    range.setStart(el.childNodes[el.childNodes.length -1], 0);
    range.collapse(true);
    sel.removeAllRanges();
    sel.addRange(range);
    el.focus();
}

RE.editor.addEventListener('paste', function(e){
	if(dj.os.isAndroid){
	    window.dj.postWithCallback("onPaste",{},function(para){
            var txt = para.text;
            document.execCommand("insertText", 0, txt);
        });
        e.preventDefault();
        e.stopPropagation();
	}else{
		var txt = e.clipboardData.getData("text/plain");
		document.execCommand("insertText", 0, txt);
		e.preventDefault();
		e.stopPropagation();
	}
})

RE.setHtml = function(contents) {
    RE.editor.innerHTML = contents;
    RE.updatePlaceholder();
}
RE.setContent = function(text,type){
	window.content = text
	window.type = type
	if (type === "reference"){
		RE.setReferenceContent(text)
	}else if (type === "reportbug"){
		RE.setReportBugContent(text)
	}else{
		RE.setHtml(text)
	}
	$("img").click(function(){
		var src = $(this).attr("src")
		var imgid = $(this).attr("imgid")
		dj.post("imgClicked",{
			src:src,
			imgid:imgid
		})
	})
}
RE.setReferenceContent = function(text){
	var div = document.createElement("div")
	div.setAttribute("contenteditable",false)
	div.setAttribute("type","create-comment")
	div.setAttribute("class","ref-content")
	div.innerHTML = text
	RE.editor.innerHTML = div.outerHTML
	RE.editor.appendChild(document.createElement("div").appendChild(document.createElement("br")))
    RE.updatePlaceholder();
}
RE.setReportBugContent = function(text){
	var div = document.createElement("div")
	//div.setAttribute("contenteditable",true)
	div.setAttribute("type","create-comment")
	div.setAttribute("class","report-error")
	
	var titlediv = document.createElement("div")
	titlediv.innerHTML = "报错"
	titlediv.setAttribute("class","error-title")
	
	var contentdiv = document.createElement("div")
	contentdiv.setAttribute("class","error-content")
	contentdiv.innerHTML = text
	
	div.appendChild(titlediv)
	div.appendChild(contentdiv)
	
	RE.editor.innerHTML = div.outerHTML
	RE.editor.appendChild(document.createElement("div").appendChild(document.createElement("br")))
    RE.updatePlaceholder();
}
RE.getHtml = function() {
	return dj.nativecallback({callback:"richeditor_html",data:RE.editor.innerHTML})
}

RE.getCommentText = function(){
    var dom = document.createElement("editorcontent")
    dom.innerHTML = RE.editor.innerHTML
    var images2remove = new Array()
    var images = dom.getElementsByTagName("img")
    for (var i=0; i<images.length; i++){
        var img =images[i]
        if (!(img.src.indexOf("http") === 0)){
            images2remove.push(img)
        }
    }
    for (var i=0; i<images2remove.length;i++){
        images2remove[i].parentNode.remove(images2remove[i])
    }
    return dj.nativecallback({callback:"richeditor_commenttext",data:dom.innerHTML})
}
RE.getPlanText = function(){
    return dj.nativecallback({callback:"richeditor_plantext",data:RE.editor.textContent})
}
RE.getImages = function(){
    var imagesrcs = new Array()
    var images = document.getElementsByTagName('img')
    for (var i=0; i<images.length; i++){
        var img =images[i].src
        imagesrcs.push(img)
    }
    return dj.nativecallback({callback:"richeditor_images",data:imagesrcs})
}
RE.bindImgEvent = function(imgid){
	$(".img-"+imgid).click(function(){
		var src = $(this).attr("src")
		var imgid = $(this).attr("imgid")
		dj.post("imgClicked",{
			src:src,
			imgid:imgid
		})
	})
}
RE.removeImage = function(imgid){
	$(".img-" + imgid).remove()
}
RE.setPlaceholderText = function(text) {
    RE.editor.setAttribute("placeholder", text)
}

RE.updatePlaceholder = function() {
    if (RE.editor.textContent.length > 0 || RE.editor.getElementsByTagName('img').length > 0) {
        RE.editor.classList.remove("placeholder")
    } else {
        RE.editor.classList.add("placeholder")
    }
}

RE.insertImage = function(url, alt) {
	RE.imgid =   RE.imgid + 1
	var imgidentifier = (new Date()).getTime() + "" + RE.imgid
    var html = '<img class="comment-img img-' + imgidentifier + '" src="' + url + '" alt="' + alt  + '" imgid="' +  imgidentifier + '" />';
    RE.insertHTML(html);
    RE.bindImgEvent(imgidentifier)
    window.scrollTo(0,RE.editor.scrollHeight)
}

RE.insertHTML = function(html) {
    var e = document.createElement('div')
    e.innerHTML = html;
    var sel = document.getSelection()
    RE.editor.appendChild(e)
    RE.updatePlaceholder()
}

RE.insertRef = function(content) {
    var e = document.createElement('div')
    e.innerHTML = html;
    var sel = document.getSelection()
    RE.editor.appendChild(e)
    RE.updatePlaceholder()
}
RE.focus = function() {
    RE.editor.focus()
}



RE.blurFocus = function() {
    RE.editor.blur()
}

window.RE = RE
